sipify.pl drops all but first word from comments

2017-06-13 03:53 PM - Sandro Santilli

Status: Closed

Priority: High

Assignee: Denis Rouzaud

Category: Python bindings / sipify

Affected QGIS version:master Regression?: No

Operating System: Easy fix?: No

Pull Request or Patch supplied:No Resolution: wontfix

Crashes QGIS or corrupts data:No Copied to github as #: 24609

Description

This diff was introduced by `git commit` (which in turn calls sipify_all.sh:

--- a/python/core/geometry/qgsabstractgeometry.sip

+++ b/python/core/geometry/qgsabstractgeometry.sip

@@ -59,7 +59,7 @@ class QgsAbstractGeometry

     enum SegmentationToleranceType

     {

-      // Maximum external angle between segments, in radians

+      // Maximum

       MaximumAngle,

       MaximumDifference

     };

Basically I cannot write more than a single word in there, it gets truncated to one word on first git commit

History

#1 - 2017-06-13 03:56 PM - Sandro Santilli

- Subject changed from sipify_all.sh drops all but first word from comments to sipify.pl drops all but first word from comments

#2 - 2017-06-13 03:57 PM - Sandro Santilli

- Assignee changed from Jürgen Fischer to Denis Rouzaud

It is sipify.pl doing the mungling, could be this block:

    # save comments and do not print them, except in SIP_RUN                    

    if ( $SIP_RUN == 0 ){                                                       

        if ( $LINE =~ m/^\s*\/\// ){                                            

            if ($LINE =~ m/^\s*\/\/\!\s*(.*?)\n?$/){                            

                $COMMENT = processDoxygenLine( $1 );                            

                $COMMENT =~ s/\n+$//;                                           

            }                                                                   

            elsif ($INPUT_LINES[$LINE_IDX-1] !~ m/\*\/.*/) {                    
                $COMMENT = '';                                                  

            }                                                                   

            next;                                                               

        }                                                                       

    }                                

#3 - 2017-06-13 04:02 PM - Sandro Santilli

The problem affected https://github.com/qgis/QGIS/pull/4728

#4 - 2017-06-14 01:26 AM - Nyall Dawson

I suspect it's because your doxygen tags are malformed. They should be:

enum SegmentationToleranceType     {

       MaximumAngle, //!< Maximum external angle between segments, in radians

       MaximumDifference

     };

Note the important inclusion of the <, which is used whenever the doxygen comment comes AFTER the member (as is the case with enum values)

#5 - 2017-06-14 01:26 AM - Nyall Dawson

- Status changed from Open to Feedback

#6 - 2017-06-15 01:10 PM - Sandro Santilli

- Status changed from Feedback to Open

Nyall moving the comment from above the enum value to its right side with '//!<' prefix makes it completely disappear from the .sip file.

#7 - 2017-06-15 01:14 PM - Nyall Dawson

That's by design - sip doesn't support documentation for enumeration values.

#8 - 2017-06-15 01:38 PM - Denis Rouzaud

- Status changed from Open to Closed

- Category changed from Build/Install to Python bindings / sipify

indeed sip does not support docstrings for bindings and the policy is just to remove them from source.

#9 - 2017-06-17 11:50 AM - Sandro Santilli

- Status changed from Closed to Reopened
If the policy is to remove them from output it is not working, as the very first word after the comment is being retained.

#10 - 2017-06-19 05:44 PM - Sandro Santilli

So Nyall and Denis: do you think https://github.com/qgis/QGIS/pull/4728 should be merged with the sip-generated broken comment in here: 

https://github.com/qgis/QGIS/pull/4728/files#diff-c57e05913a8dc3395f4b0f7d7f926293L61 ?

Those comments in .sip file basically become:

    enum SegmentationToleranceType

    {

      // Maximum

      // to

      MaximumAngle,

      // Maximum

      // curve

      MaximumDifference

    };

#11 - 2017-09-28 09:41 AM - Denis Rouzaud

- Status changed from Reopened to Closed

#12 - 2017-09-28 10:18 AM - Sandro Santilli

- Status changed from Closed to Reopened

Why closed ? Was it fixed ? If so by which commit ?

#13 - 2017-09-28 10:26 AM - Denis Rouzaud

No issue here to me. The enum docs are not exported to sip files as they are not used.

As Nyall suggested you can use //!< which makes it a little nicer.

#14 - 2017-09-28 10:38 AM - Giovanni Manghi

Denis Rouzaud wrote:

No issue here to me. The enum docs are not exported to sip files as they are not used.

As Nyall suggested you can use //!< which makes it a little nicer.

so "won't fix"?

#15 - 2017-09-28 10:46 AM - Denis Rouzaud

- Resolution set to wontfix

- Status changed from Reopened to Closed
